/**
* \file categorieobjet.hpp
* \brief GS::CategorieObjet
* \author Yoha
* \version alpha-0.0.07
* \date Juin 2009
*
* Appartient au systeme de jeu
*
*/

#ifndef CATEGORIEOBJET_HPP
#define CATEGORIEOBJET_HPP

/// Mode dynamique
#define SFML_DYNAMIC

#include <iostream>

/// Game System
namespace GS
{
	/// Definit une categorie d'objet
	class CategorieObjet
	{
		public:
			/// \brief Constructeur
			CategorieObjet();
			/// \brief Destructeur
			~CategorieObjet();
			
			/// \brief Accesseur: definit l'Id de la categorie d'objet
			/// \param id Id a cahrger
			void SetId(const unsigned int id);
			/// \brief Accesseur: definit le nom de la categorie d'objet
			/// \param nom Nom a charger
			void SetNom(const std::string nom);
			
			/// \brief Accesseur: renvoie l'Id de la categorie d'objet
			unsigned int GetId() const;
			/// \brief Accesseur: renvoie le nom de la categorie d'objet
			std::string GetNom() const;
		
		private:
			/// Id de la categorie d'objet
			unsigned int mId;
			/// Nom de la categorie d'objet
			std::string mNom;
	};
}

#endif
