#ifndef ETRE_CPP
#define ETRE_CPP

#include "etre.hpp"

#include "gestionnaire.hpp"
#include "fonctions.hpp"

namespace GS
{
	unsigned int Etre::mProchainIdentifiant = 0;
	
	Etre::Etre(GS::Etre* parent, TiXmlElement* element) : mXml(element),mIdentifiant(0), mX(0), mY(0), mLargeur(0), mHauteur(0), mPere(parent), mType(Types::PasDeType)
	{
		if (!mXml || !ChargeXmlParametre(mXml, "id", mIdentifiant))
			mIdentifiant = mProchainIdentifiant;
		
		if (mIdentifiant >= mProchainIdentifiant)
			mProchainIdentifiant = mIdentifiant + 1;
	}
	
	Etre::Etre(lua_State*)
	{
	}
	
	
	Etre::~Etre()
	{
	}
	
	void
	Etre::Charge()
	{
	}
	
	TiXmlElement*
	Etre::Sauvegarde()
	{
		TiXmlElement* retour = new TiXmlElement("Etre");
		TiXmlElement* selement;
		
		retour->SetAttribute("id", mIdentifiant);
		
		selement = new TiXmlElement("Abscisse");
		retour->LinkEndChild(selement);
		selement->SetDoubleAttribute("valeur", mX);
		
		selement = new TiXmlElement("Ordonnee");
		retour->LinkEndChild(selement);
		selement->SetDoubleAttribute("valeur", mY);
		
		selement = new TiXmlElement("Largeur");
		retour->LinkEndChild(selement);
		selement->SetDoubleAttribute("valeur", mLargeur);
		
		selement = new TiXmlElement("Hauteur");
		retour->LinkEndChild(selement);
		selement->SetDoubleAttribute("valeur", mHauteur);
		
		return retour;
	}
	
	bool
	Etre::Catch(const double x, const double y)
	{
		return mX <= x && x < mX + mLargeur && mY <= y && y <= mY + mHauteur;
	}
	
	void
	Etre::SetPosition(const double x, const double y)
	{
		mX = x;
		mY = y;
	}
	
	unsigned int
	Etre::GetId() const
	{
		return mIdentifiant;
	}
	
	double
	Etre::GetX() const
	{
		return mX;
	}
	
	double
	Etre::GetY() const
	{
		return mY;
	}
	
	double
	Etre::GetLargeur() const
	{
		return mLargeur;
	}
	
	double
	Etre::GetHauteur() const
	{
		return mHauteur;
	}
	
	Types::Names
	Etre::GetType() const
	{
		return mType;
	}
}
#endif
