/**
* \file gamesystem.hpp
* \brief Systeme de jeu (ReceveurChaine)
* \author Yoha
* \version alpha-0.0.07
* \date Aot 2009
*
* Regroupe les informations du systeme de jeu
*
*/

#ifndef GAMESYSTEM_HPP
#define GAMESYSTEM_HPP

/// Mode dynamique
#define SFML_DYNAMIC

#include <iostream>

/// Cette classe permet de recevoir des phrases puis de les traiter
class ReceveurChaine
{
	public:
		/// \brief Cette methode traite les phrases recues, par defaut, elle les affiche dans la console
		/// \param phrase La phrase transmise
		virtual void RecoitChaine(const std::string phrase) = 0;
};

/// Game System
namespace GS
{
	/// Regroupe les nom des differents types
	namespace Types
	{
		/// Differents types
		enum Names
		{
			PasDeType,
			Monde,
			Personnage,
			Ressource,
			Batiment,
			Objet
		};
	}
	
	/// Regroupe les noms des valeurs
	namespace Valeurs
	{
		/// Differentes valeurs
		enum Names
		{
			Id,
			IdRessource
		};
	}
}

#endif
