#ifndef GESTIONNAIRE_CPP
#define GESTIONNAIRE_CPP

#define NOMBRE_FICHIERS_XML 12

#include "gestionnaire.hpp"

#include "projet.hpp"
#include "fonctions.hpp"
#include "data.hpp"

Manager* GestionnaireDonnees = new Manager();

Manager::Manager()
{
	mNombreImages = 0;
	mNombreSprites = 0;
	mNombreTypesTerrains = 0;
	mNombreTypesRessources = 0;
	mNombreTypesTerRessources = 0;
	mNombreStatuts = 0;
	mNombreCategoriesObjets = 0;
	mNombreTypesObjets = 0;
	mNombreTypesBatiments = 0;
	mNombreRaces = 0;
}

Manager::~Manager()
{
	unsigned int i = 0;
	while (i < mNombreSprites)
	{
		delete mSprites[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreTypesTerrains)
	{
		delete mTypesTerrains[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreTypesRessources)
	{
		delete mTypesRessources[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreTypesTerRessources)
	{
		delete mTypesTerRessources[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreStatuts)
	{
		delete mStatuts[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreCategoriesObjets)
	{
		delete mCategoriesObjets[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreTypesObjets)
	{
		delete mTypesObjets[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreTypesBatiments)
	{
		delete mTypesBatiments[i];
		i++;
	}
	
	i = 0;
	while (i < mNombreRaces)
	{
		delete mRaces[i];
		i++;
	}
}

void
Manager::ChargeXml()
{
	TiXmlDocument* documents[NOMBRE_FICHIERS_XML];
	TiXmlElement* root = NULL;
	TiXmlElement* element = NULL;
	TiXmlElement* selement = NULL;
	
	std::string fichiersXml[NOMBRE_FICHIERS_XML] =
		{
			"images.xml",
			"sprites.xml",
			"config.xml",
			"terrains.xml",
			"ressources.xml",
			"statuts.xml",
			"terrainressources.xml",
			"batiments.xml",
			"categoriesobjets.xml",
			"objets.xml",
			"races.xml",
			"sfenetres.xml"
		};
	
	// reperes dans les boucles
	unsigned int i = 0;
	unsigned int j = 0;
	
	// id de l'element dans le vector
	unsigned int id = 0;
	
	// types de recherches XML
	std::string chaine = "";
	unsigned int entier = 0;
	double decimal = 0;
	
	// ressources de construction ou de fabrication
	unsigned int num;
	double quantite;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		documents[i] = new TiXmlDocument();
		if (!documents[i]->LoadFile( (R_CONFIG + fichiersXml[i]).c_str() ))
			CastErreur("Erreur lors du chargement de \"" + fichiersXml[i] + "\"");
		i++;
	}
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Images")) )
		{
			id = 0;
			
			element = element->FirstChildElement("Image");
			while (element)
			{
				if (ChargeXmlValeur(element, "Fichier", chaine))
				{
					if (!ChargeXmlParametre(element, "id", id))
						id = mNombreImages + 1;
					if (id > mNombreImages)
					{
						mNombreImages = id;
						mImages.resize(mNombreImages);
						mChargees.resize(mNombreImages);
						mAdresses.resize(mNombreImages);
					}
					
					j = id - 1;
					
					mImages[j] = new sf::Image();
					mChargees[j] = false;
					mAdresses[j] = new std::string(chaine);
				}
				
				element = element->NextSiblingElement("Image");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.05;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Sprites")) )
		{
			id = 0;
			int x;
			int y;
			int l;
			int h;
			sf::Image* imageTemp;
			
			element = element->FirstChildElement("Sprite");
			while (element)
			{
				imageTemp = NULL;
				
				if (!ChargeXmlParametre(element,"id", id))
					id = mNombreSprites + 1;
				if (id > mNombreSprites)
				{
					mNombreSprites = id;
					mSprites.resize(mNombreSprites);
				}
				
				j = id - 1;
				
				if (ChargeXmlValeur(element, "Image", entier) && 1 <= entier && entier <= mNombreImages)
					imageTemp = GetImage(entier - 1);
				
				if (imageTemp)
				{
					if (!mSprites[j])
						mSprites[j] = new sf::Sprite();
					
					mSprites[j]->SetImage(*imageTemp);
					
					if (ChargeXmlValeur(element, "Abscisse", entier))
						x = entier;
					else
						x = 0;
					
					if (ChargeXmlValeur(element, "Ordonnee", entier))
						y = entier;
					else
						y = 0;
					
					if (ChargeXmlValeur(element, "Largeur", entier))
						l = entier;
					else
						l = 0;
					
					if (ChargeXmlValeur(element, "Hauteur", entier))
						h = entier;
					else
						h = 0;
					
					mSprites[j]->SetSubRect( sf::IntRect(x, y, x + l, y + h) );
				}
				else
				{
					mSprites[j] = new sf::Sprite( sf::Image(0, 0) );
					CastErreur("Erreur lors du chargement d'un sprite", false);
				}
				
				element = element->NextSiblingElement("Sprite");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.10;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Config")) )
		{
			if (ChargeXmlValeur(element, "LargeurTerrain", entier) && entier > 0)
				Prgm::Monde::Largeur = entier;
			
			if (ChargeXmlValeur(element, "HauteurTerrain", entier) && entier > 0)
				Prgm::Monde::Hauteur = entier;
			
			if (ChargeXmlValeur(element, "Pesanteur", decimal) && decimal > 0)
				Prgm::Monde::Pesanteur = decimal;
			
			
			if (ChargeXmlValeur(element, "ImageCurseurs", entier))
				Prgm::Curseurs::Image = GetImage(entier - 1);
			
			if (ChargeXmlValeur(element, "CoteSpriteCurseur", entier))
				Prgm::Curseurs::CoteSprite = entier;
				
			if (ChargeXmlValeur(element, "CoteCurseur", entier))
				Prgm::Curseurs::Cote = entier;
			
			
			if (ChargeXmlValeur(element, "SpriteBulle", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::Textes::Fond = mSprites[entier - 1];
			
			
			if (ChargeXmlValeur(element, "LargeurBarresChargement", decimal) && decimal > 0)
				Prgm::BarresChargement::Largeur = decimal;
			
			if (ChargeXmlValeur(element, "HauteurBarresChargement", decimal) && decimal > 0)
				Prgm::BarresChargement::Hauteur = decimal;
			
			if (ChargeXmlValeur(element, "EpaisseurContoursBarresChargement", decimal) && decimal >= 0)
				Prgm::BarresChargement::EpaisseurContours = decimal;
			
			if (ChargeXmlValeur(element, "EcartBarresChargement", decimal))
				Prgm::BarresChargement::Ecart = decimal;
			
			if (ChargeXmlValeur(element, "MargeVerticaleBarresChargement", decimal))
				Prgm::BarresChargement::MargeVerticale = decimal;
			
			if (ChargeXmlValeur(element, "MargeHorizontaleBarresChargement", decimal))
				Prgm::BarresChargement::MargeHorizontale = decimal;
			
			if (ChargeXmlValeur(element, "TailleTexteBarresChargement", decimal))
				Prgm::BarresChargement::TailleTexte = decimal;
			
			
			if (ChargeXmlValeur(element, "ImagePersoDefaut", entier))
				Prgm::Personnage::ImageDefaut = GetImage(entier - 1);
			
			if (ChargeXmlValeur(element, "LargeurSprite", entier))
				Prgm::Personnage::LargeurSprite = entier;
				
			if (ChargeXmlValeur(element, "HauteurSprite", entier))
				Prgm::Personnage::HauteurSprite = entier;
			
			if (ChargeXmlValeur(element, "LargeurPerso", entier))
				Prgm::Personnage::Largeur = entier;
				
			if (ChargeXmlValeur(element, "HauteurPerso", entier))
				Prgm::Personnage::Hauteur = entier;
			
			if (ChargeXmlValeur(element, "PasParSeconde", decimal))
				Prgm::Personnage::PasParSeconde = decimal;
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.15;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Terrains")) )
		{
			id = 0;
			
			if (ChargeXmlValeur(element, "LargeurTerrain", entier))
				Prgm::Terrains::Largeur = entier;
			
			if (ChargeXmlValeur(element, "HauteurTerrain", entier))
				Prgm::Terrains::Hauteur = entier;
			
			if (ChargeXmlValeur(element, "CoteCarte", entier))
				Prgm::Terrains::CoteCarte = entier;
			
			Prgm::Terrains::LargeurBoutDeMonde = Prgm::Terrains::CoteCarte * Prgm::Terrains::Largeur;
			Prgm::Terrains::HauteurBoutDeMonde = Prgm::Terrains::CoteCarte * Prgm::Terrains::Hauteur;
			
			element = element->FirstChildElement("Terrain");
			while (element)
			{
				if (!ChargeXmlParametre(element,"id", id))
					id = mNombreTypesTerrains + 1;
				if (id > mNombreTypesTerrains)
				{
					mNombreTypesTerrains = id;
					mTypesTerrains.resize(mNombreTypesTerrains);
				}
				
				j = id - 1;
				
				if (!mTypesTerrains[j])
					mTypesTerrains[j] = new GS::TypeTerrain();
				
				if (ChargeXmlValeur(element, "Sprite", entier) && 1 <= entier && entier <= mNombreSprites)
					mTypesTerrains[j]->SetSprite(mSprites[entier - 1]);
				
				if (ChargeXmlValeur(element, "FacteurDeplacement", decimal) && decimal >= 0)
					mTypesTerrains[j]->SetFacteurVitesse(decimal);
				
				if (ChargeXmlValeur(element, "Ressources", chaine))
					mTypesTerrains[j]->SetPorteRessources(true);
				else
					mTypesTerrains[j]->SetPorteRessources(false);
				
				if (ChargeXmlValeur(element, "Constructible", chaine))
					mTypesTerrains[j]->SetConstructible(true);
				else
					mTypesTerrains[j]->SetConstructible(false);
				
				if (ChargeXmlValeur(element, "Probabilite", decimal) && decimal >= 0)
					mTypesTerrains[j]->SetProbabilite(decimal);
				
				element = element->NextSiblingElement("Terrain");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.20;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Ressources")) )
		{
			id = 0;
			
			if (ChargeXmlValeur(element, "CoteIcone", entier))
				Prgm::Ressources::CoteIcone = entier;
			
			element = element->FirstChildElement("Ressource");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreTypesTerRessources + 1;
				if (id > mNombreTypesTerRessources)
				{
					mNombreTypesRessources = id;
					mTypesRessources.resize(mNombreTypesRessources);
				}
				
				j = id - 1;
				
				if (!mTypesRessources[j])
					mTypesRessources[j] = new GS::TypeRessource();
				
				mTypesRessources[j]->SetId(j);
				
				if (ChargeXmlValeur(element, "Nom", chaine))
					mTypesRessources[j]->SetNom(chaine);
				
				if (ChargeXmlValeur(element, "MasseUnitaire", decimal))
					mTypesRessources[j]->SetMasseUnitaire(decimal);
				
				if (ChargeXmlValeur(element, "NomFichierImage", chaine))
					mTypesRessources[j]->ChargeImage(chaine);
				
				if (ChargeXmlValeur(element, "VitesseTransformation", decimal))
					mTypesRessources[j]->SetVitesseTransformation(decimal);
				
				selement = element->FirstChildElement("Transformation");
				if (selement)
				{
					
					selement = selement->FirstChildElement("Ressource");
					while (selement)
					{
						num = 0;
						quantite = 0;
						
						if (ChargeXmlParametre(selement, "valeur", entier))
							num = entier - 1;
						
						selement = selement->NextSiblingElement("QuantiteUnitaire");
						
						if (selement->QueryDoubleAttribute("valeur", &decimal) == TIXML_SUCCESS && decimal > 0)
							quantite = decimal;
						
						if (quantite > 0)
							mTypesRessources[j]->AjouteRessourceNecessaire(num, quantite);
						
						selement = selement->NextSiblingElement("Ressource");
					}
				}
				
				element = element->NextSiblingElement("Ressource");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.25;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("TerrainRessources")) )
		{
			id = 0;
			
			if (ChargeXmlValeur(element, "LargeurRessource", entier))
				Prgm::TerRessources::Largeur = entier;
			
			if (ChargeXmlValeur(element, "HauteurRessource", entier))
				Prgm::TerRessources::Hauteur = entier;
			
			element = element->FirstChildElement("TerrainRessource");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreTypesTerRessources + 1;
				if (id > mNombreTypesTerRessources)
				{
					mNombreTypesTerRessources = id;
					mTypesTerRessources.resize(mNombreTypesTerRessources);
				}
				
				j = id - 1;
				
				if (!mTypesTerRessources[j])
					mTypesTerRessources[j] = new GS::TypeTerRessource();
				
				mTypesTerRessources[j]->SetId(j);
				
				if (ChargeXmlValeur(element, "Sprite", entier) && 1 <= entier && entier <= mNombreSprites)
					mTypesTerRessources[j]->SetSprite(mSprites[entier - 1]);
				
				if (ChargeXmlValeur(element, "Nom", chaine))
					mTypesTerRessources[j]->SetNom(chaine);
				
				if (ChargeXmlValeur(element, "Action", chaine))
					mTypesTerRessources[j]->SetAction(chaine);
				
				if (ChargeXmlValeur(element, "Ressource", entier) && 1 <= entier && entier <= mNombreTypesRessources)
					mTypesTerRessources[j]->SetTypeRessource(mTypesRessources[entier - 1]);
				
				if (ChargeXmlValeur(element, "VitesseRecolte", decimal))
					mTypesTerRessources[j]->SetRessourceParSeconde(decimal);
				
				element = element->NextSiblingElement("TerrainRessource");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.30;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Statuts")) )
		{
			id = 0;
			
			element = element->FirstChildElement("Statut");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreStatuts + 1;
				if (id > mNombreStatuts)
				{
					mNombreStatuts = id;
					mStatuts.resize(mNombreStatuts);
				}
				
				j = id - 1;
				
				if (!mStatuts[j])
					mStatuts[j] = new GS::Statut();
				
				if (ChargeXmlValeur(element, "Nom", chaine))
					mStatuts[j]->SetNom(chaine);
				
				if (ChargeXmlValeur(element, "ValeurDefaut", decimal) && decimal >= 0)
					mStatuts[j]->SetValeurDefaut(decimal);
				
				element = element->NextSiblingElement("Statut");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.35;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("CategoriesObjets")) )
		{
			id = 0;
			
			element = element->FirstChildElement("CategorieObjet");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreCategoriesObjets + 1;
				if (id > mNombreCategoriesObjets)
				{
					mNombreCategoriesObjets = id;
					mCategoriesObjets.resize(mNombreCategoriesObjets);
				}
				
				j = id - 1;
				
				if (!mCategoriesObjets[j])
					mCategoriesObjets[j] = new GS::CategorieObjet();
				
				mCategoriesObjets[j]->SetId(j);
				
				if (ChargeXmlValeur(element, "Nom", chaine))
					mCategoriesObjets[j]->SetNom(chaine);
				
				element = element->NextSiblingElement("CategorieObjet");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.40;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Objets")) )
		{
			id = 0;
			
			if (ChargeXmlValeur(element, "CoteIcone", entier))
				Prgm::Objets::CoteIcone = entier;
			
			element = element->FirstChildElement("Objet");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreTypesObjets + 1;
				if (id > mNombreTypesObjets)
				{
					mNombreTypesObjets = id;
					mTypesObjets.resize(mNombreTypesObjets);
				}
				
				j = id - 1;
				
				if (!mTypesObjets[j])
					mTypesObjets[j] = new GS::TypeObjet();
				
				mTypesObjets[j]->SetId(j);
				
				if (ChargeXmlValeur(element, "Nom", chaine))
					mTypesObjets[j]->SetNom(chaine);
				
				if (ChargeXmlValeur(element, "Description", chaine))
					mTypesObjets[j]->SetDescription(chaine);
				
				if (ChargeXmlValeur(element, "DureeFabrication", decimal) && decimal > 0)
					mTypesObjets[j]->SetDureeFabrication(decimal);
				
				if (ChargeXmlValeur(element, "Categorie", entier) && entier >= 1)
					mTypesObjets[j]->SetCategorieObjet(mCategoriesObjets[entier - 1]);
				
				
				if (ChargeXmlValeur(element, "NomFichierImage", chaine))
					mTypesObjets[j]->ChargeImage(chaine);
				
				
				selement = element->FirstChildElement("Fabrication");
				if (selement)
				{
					selement = selement->FirstChildElement("Ressource");
					while (selement)
					{
						num = 0;
						quantite = 0;
						
						if (ChargeXmlParametre(selement, "valeur", entier))
							num = entier - 1;
						
						selement = selement->NextSiblingElement("Quantite");
						
						if (selement->QueryDoubleAttribute("valeur", &decimal) == TIXML_SUCCESS && decimal > 0)
							quantite = decimal;
						
						if (quantite > 0)
							mTypesObjets[j]->AjouteRessourceNecessaire(num, quantite);
						
						selement = selement->NextSiblingElement("Ressource");
					}
				}
				
				element = element->NextSiblingElement("Objet");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.45;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Batiments")) )
		{
			id = 0;
			
			if (ChargeXmlValeur(element, "ConstructionPossible", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::Batiments::SpriteConstructionPossible = mSprites[entier - 1];
			
			if (ChargeXmlValeur(element, "ConstructionImpossible", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::Batiments::SpriteConstructionImpossible = mSprites[entier - 1];
			
			if (ChargeXmlValeur(element, "CoteSpriteBouton", entier))
				Prgm::Batiments::CoteSpriteBouton = entier;
			
			if (ChargeXmlValeur(element, "CoteBouton", entier))
				Prgm::Batiments::CoteBouton = entier;
			
			if (ChargeXmlValeur(element, "NombreLignesPanneau", entier) && entier >= 1)
				Prgm::Batiments::NombreLignesPanneau = entier;
			
			if (ChargeXmlValeur(element, "DebutConstruction", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::Batiments::DebutConstruction = mSprites[entier - 1];
			
			element = element->FirstChildElement("Batiment");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreTypesBatiments + 1;
				
				if (id > mNombreTypesBatiments)
				{
					mNombreTypesBatiments = id;
					mTypesBatiments.resize(mNombreTypesBatiments);
				}
				
				j = id - 1;
				
				if (!mTypesBatiments[j])
					mTypesBatiments[j] = new GS::TypeBatiment();
				
				mTypesBatiments[j]->SetId(j);
				
				if (ChargeXmlValeur(element, "Nom", chaine))
					mTypesBatiments[j]->SetNom(chaine);
				
				if (ChargeXmlValeur(element, "Description", chaine))
					mTypesBatiments[j]->SetDescription(chaine);
				
				if (ChargeXmlValeur(element, "NomFichierStructure", chaine))
					mTypesBatiments[j]->ChargeFichierStructure(chaine);
				
				if (ChargeXmlValeur(element, "NomFichierBouton", chaine))
					mTypesBatiments[j]->ChargeFichierBouton(chaine);
				
				if (ChargeXmlValeur(element, "MaxVie", decimal) && decimal > 0)
					mTypesBatiments[j]->SetMaxVie(decimal);
				
				if (ChargeXmlValeur(element, "LargeurBatiment", entier))
					mTypesBatiments[j]->SetLargeurBatiment(entier);
				
				if (ChargeXmlValeur(element, "HauteurBatiment", entier))
					mTypesBatiments[j]->SetHauteurBatiment(entier);
				
				if (ChargeXmlValeur(element, "LargeurSprite", entier))
					mTypesBatiments[j]->SetLargeurSprite(entier);
				
				if (ChargeXmlValeur(element, "HauteurSprite", entier))
					mTypesBatiments[j]->SetHauteurSprite(entier);
				
				if (ChargeXmlValeur(element, "NombreEtats", entier) && entier > 1)
					mTypesBatiments[j]->SetNombreEtats(entier);
				
				selement = element->FirstChildElement("Construction");
				if (selement)
				{
					selement = selement->FirstChildElement("Ressource");
					while (selement)
					{
						num = 0;
						quantite = 0;
						
						if (ChargeXmlParametre(selement, "valeur", entier))
							num = entier - 1;
						
						selement = selement->NextSiblingElement("Quantite");
						
						if (selement->QueryDoubleAttribute("valeur", &decimal) == TIXML_SUCCESS && decimal > 0)
							quantite = decimal;
						
						if (quantite > 0)
							mTypesBatiments[j]->AjouteRessourceNecessaire(num, quantite);
						
						selement = selement->NextSiblingElement("Ressource");
					}
				}
				
				selement = element->FirstChildElement("Fabrication");
				if (selement)
				{
					selement = selement->FirstChildElement("Objet");
					while (selement)
					{
						if (ChargeXmlParametre(selement, "valeur", entier))
							mTypesBatiments[j]->AjouteObjetFabricable (entier - 1);
						
						selement = selement->NextSiblingElement("Objet");
					}
				}
				
				selement = element->FirstChildElement("Transformation");
				if (selement)
				{
					selement = selement->FirstChildElement("Ressource");
					while (selement)
					{
						if (ChargeXmlParametre(selement, "valeur", entier))
							mTypesBatiments[j]->AjouteRessourceTransformable(entier - 1);
						
						selement = selement->NextSiblingElement("Ressource");
					}
				}
				
				element = element->NextSiblingElement("Batiment");
			}
		}
		
		i++;
	}
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("Races")) )
		{
			id = 0;
			
			element = element->FirstChildElement("Race");
			while (element)
			{
				if (!ChargeXmlParametre(element, "id", id))
					id = mNombreRaces + 1;
				if (id > mNombreRaces)
				{
					mNombreRaces = id;
					mRaces.resize(mNombreRaces);
				}
				
				j = id - 1;
				
				if (!mRaces[j])
					mRaces[j] =new GS::Race();
				
				if (ChargeXmlValeur(element, "Description", chaine))
					mRaces[j]->SetDescription(chaine);
				
				
				selement = element->FirstChildElement("Denominations");
				if (selement)
				{
					if (ChargeXmlValeur(element, "SingulierMasculin", chaine))
						mRaces[j]->SetDenominationSingulierMasculin(chaine);
					
					if (ChargeXmlValeur(element, "SingulierFeminin", chaine))
						mRaces[j]->SetDenominationSingulierFeminin(chaine);
					
					if (ChargeXmlValeur(element, "PlurielMasculin", chaine))
						mRaces[j]->SetDenominationPlurielMasculin(chaine);
					
					if (ChargeXmlValeur(element, "PlurielFeminin", chaine))
						mRaces[j]->SetDenominationPlurielFeminin(chaine);
					
				}
				
				element = element->NextSiblingElement("Race");
			}
		}
		
		i++;
	}
	
	Prgm::ElementsInterface::AvancementChargement = 0.50;
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		root = documents[i]->FirstChildElement("VendettaConfig");
		
		if ( (element = root->FirstChildElement("SFenetres")) )
		{
			if (ChargeXmlValeur(element, "TailleTexteTitre", decimal) && decimal >= 1)
				Prgm::SFenetres::TailleTexteTitre = decimal;
			
			if (ChargeXmlValeur(element, "OrdonneeTitre", decimal))
				Prgm::SFenetres::OrdonneeTitre = decimal;
			
			
			if (ChargeXmlValeur(element, "TailleTexte", decimal) && decimal >= 1)
				Prgm::SFenetres::TailleTexte = decimal;
			
			if (ChargeXmlValeur(element, "Sprite", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::SFenetres::Sprite = mSprites[entier - 1];
			
			if (ChargeXmlValeur(element, "FlecheGauche", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::Fleches::FlecheGauche = mSprites[entier - 1];
			
			if (ChargeXmlValeur(element, "FlecheDroite", entier) && 1 <= entier && entier <= mNombreSprites)
				Prgm::Fleches::FlecheDroite = mSprites[entier - 1];
			
			if (ChargeXmlValeur(element, "Cote", entier) && entier > 0)
				Prgm::Fleches::Cote = entier;
			
			if ( (selement = element->FirstChildElement("Batiment")) )
			{
				
				if (ChargeXmlValeur(selement, "TailleTexteNom", decimal) && decimal >= 1)
					Prgm::SFenetres::Batiment::TailleTexteNom = decimal;
				
				if (ChargeXmlValeur(selement, "OrdonneeNom", decimal))
					Prgm::SFenetres::Batiment::OrdonneeNom = decimal;
				
				
				if (ChargeXmlValeur(selement, "AbscsisseListes", decimal))
					Prgm::SFenetres::Batiment::AbscsisseListes = decimal;
				
				if (ChargeXmlValeur(selement, "OrdonneeListes", decimal))
					Prgm::SFenetres::Batiment::OrdonneeListes = decimal;
				
				
				if (ChargeXmlValeur(selement, "LargeurColoneNoms", decimal) && decimal > 0)
					Prgm::SFenetres::Batiment::LargeurColoneNoms = decimal;
				
				if (ChargeXmlValeur(selement, "EspaceInterligne", decimal) && decimal > 0)
					Prgm::SFenetres::Batiment::EspaceInterligne = decimal;
				
				if (ChargeXmlValeur(selement, "TransformationRessources", entier) && 1 <= entier && entier <= mNombreSprites)
					Prgm::SFenetres::Batiment::TransformationRessources = mSprites[entier - 1];
				
				if (ChargeXmlValeur(selement, "FabricationObjets", entier) && 1 <= entier && entier <= mNombreSprites)
					Prgm::SFenetres::Batiment::FabricationObjets = mSprites[entier - 1];
				
				if (ChargeXmlValeur(selement, "CoteBoutonTransformationFabrication", entier) && entier > 0)
					Prgm::SFenetres::Batiment::CoteBoutonTransformationFabrication = entier;
				
				if (ChargeXmlValeur(selement, "AbscisseBoutonTransformationFabrication", decimal))
					Prgm::SFenetres::Batiment::AbscisseBoutonTransformationFabrication = decimal;
				
				if (ChargeXmlValeur(selement, "OrdonneeBoutonTransformationFabrication", decimal))
					Prgm::SFenetres::Batiment::OrdonneeBoutonTransformationFabrication = decimal;
				
				if (ChargeXmlValeur(selement, "AbscisseQuantiteRessourceATransformer", decimal))
					Prgm::SFenetres::Batiment::AbscisseQuantiteRessourceATransformer = decimal;
				
				if (ChargeXmlValeur(selement, "OrdonneeQuantiteRessourceATransformer", decimal))
					Prgm::SFenetres::Batiment::OrdonneeQuantiteRessourceATransformer = decimal;
			}
			
			if ( (selement = element->FirstChildElement("Inventaire")) )
			{
				if (ChargeXmlValeur(selement, "SpriteGrilleObjets", entier) && 1 <= entier && entier <= mNombreSprites)
					Prgm::SFenetres::Inventaire::SpriteGrilleObjets = mSprites[entier - 1];
				
				if (ChargeXmlValeur(selement, "CoteCellule", decimal) && decimal > 0)
					Prgm::SFenetres::Inventaire::CoteCellule = decimal;
				
				if (ChargeXmlValeur(selement, "AbscisseGrilleObjets", decimal))
					Prgm::SFenetres::Inventaire::AbscisseGrilleObjets = decimal;
				
				if (ChargeXmlValeur(selement, "OrdonneeGrilleObjets", decimal))
					Prgm::SFenetres::Inventaire::OrdonneeGrilleObjets = decimal;
				
				if (ChargeXmlValeur(selement, "MargeSuperieureGrilleObjets", decimal) && decimal > 0)
					Prgm::SFenetres::Inventaire::MargeSuperieureGrilleObjets = decimal;
				
				if (ChargeXmlValeur(selement, "NombreLignes", entier) && entier >= 1)
					Prgm::SFenetres::Inventaire::NombreLignes = entier;
				
				if (ChargeXmlValeur(selement, "NombreColones", entier) && entier >= 1)
					Prgm::SFenetres::Inventaire::NombreColones = entier;
			}
		}
		
		i++;
	}
	
	i = 0;
	while (i < NOMBRE_FICHIERS_XML)
	{
		delete documents[i];
		i++;
	}
}

sf::Image*
Manager::GetImage(const unsigned int num)
{
	if (num < mNombreImages)
	{
		if (!mChargees[num])
		{
			if (!mImages[num]->LoadFromFile(R_IMAGES + *mAdresses[num] ))
				CastErreur("Erreur lors du chargement de \"" + *mAdresses[num] + "\"", false);
			else
				mChargees[num] = true;
		}
		return mImages[num];
	}
	else
		return NULL;
}

unsigned int
Manager::GetNombreTypesTerrains() const
{
	return mTypesTerrains.size();
}

GS::TypeTerrain*
Manager::GetTypeTerrain(const unsigned int num)
{
	if (num < mTypesTerrains.size())
		return mTypesTerrains[num];
	else
		return NULL;
}

unsigned int
Manager::GetNombreTypesRessources() const
{
	return mTypesRessources.size();
}

GS::TypeRessource*
Manager::GetTypeRessource(const unsigned int num)
{
	if (num < mTypesRessources.size())
		return mTypesRessources[num];
	else
		return NULL;
}

unsigned int
Manager::GetNombreTypesTerRessources() const
{
	return mTypesTerRessources.size();
}

GS::TypeTerRessource*
Manager::GetTypeTerRessource(const unsigned int num)
{
	if (num < mTypesTerRessources.size())
		return mTypesTerRessources[num];
	else
		return NULL;
}

unsigned int
Manager::GetNombreStatuts() const
{
	return mStatuts.size();
}

GS::Statut*
Manager::GetStatut(const unsigned int num)
{
	if (num < mStatuts.size())
		return mStatuts[num];
	else
		return NULL;
}

unsigned int
Manager::GetNombreCategoriesObjets() const
{
	return mCategoriesObjets.size();
}

GS::CategorieObjet*
Manager::GetCategorieObjet(const unsigned int num)
{
	if (num < mCategoriesObjets.size())
		return mCategoriesObjets[num];
	else
		return NULL;
}

unsigned int
Manager::GetNombreTypesObjets() const
{
	return mTypesObjets.size();
}

GS::TypeObjet*
Manager::GetTypeObjet(const unsigned int num)
{
	if (num < mTypesObjets.size())
		return mTypesObjets[num];
	else
		return NULL;
}

unsigned int
Manager::GetNombreTypesBatiments() const
{
	return mTypesBatiments.size();
}

GS::TypeBatiment*
Manager::GetTypeBatiment(const unsigned int num)
{
	if (num < mTypesBatiments.size())
		return mTypesBatiments[num];
	else
		return NULL;
}

#endif
