#ifndef OBJET_CPP
#define OBJET_CPP

#include "objet.hpp"
#include "fonctions.hpp"
#include "gestionnaire.hpp"

namespace GS
{
	Objet::Objet(GS::Etre* parent, TiXmlElement* element) : Etre(parent, element), mTypeObjet(NULL)
	{
		mType = Types::Objet;
	}
	
	Objet::~Objet()
	{
	}
	
	void
	Objet::Charge()
	{
		if (mXml)
		{
			unsigned int type;
			ChargeXmlValeur(mXml, "Type", type);
			mTypeObjet = GestionnaireDonnees->GetTypeObjet(type);
		}
	}
	
	TiXmlElement*
	Objet::Sauvegarde()
	{
		TiXmlElement* retour = new TiXmlElement("Objet");
		retour->SetAttribute("id", mIdentifiant);
		TiXmlElement* selement;
		
		selement = new TiXmlElement("Type");
		retour->LinkEndChild(selement);
		selement->SetAttribute("valeur", mTypeObjet->GetId());
		
		return retour;
	}
	
	void
	Objet::SetTypeObjet(TypeObjet* type)
	{
		mTypeObjet = type;
	}
	
	TypeObjet*
	Objet::GetTypeObjet() const
	{
		return mTypeObjet;
	}
}

#endif
