/**
* \file objet.hpp
* \brief GS::Objet
* \author Yoha
* \version alpha-0.0.07
* \date Aot 2009
*
* Appartient au systeme de jeu
*
*/

#ifndef OBJET_HPP
#define OBJET_HPP

/// Mode dynamique
#define SFML_DYNAMIC

#include "etre.hpp"
#include "typeobjet.hpp"

/// Game System
namespace GS
{
	/// Definit un d'objet
	class Objet : public Etre
	{
		public:
			/// \brief Constructeur
			Objet(GS::Etre* parent, TiXmlElement* element = NULL);
			/// \brief Destructeur
			virtual ~Objet();
			
			/// \brief Charge une sauvegarde
			/// \param element Element contenant la sauvegarde
			void Charge();
			/// \brief Sauvegarde
			TiXmlElement* Sauvegarde();
			
			/// \brief Accesseur: definit le type de l'objet
			/// \param type Type d'objet a charger
			void SetTypeObjet(TypeObjet* type);
			
			/// \brief Accesseur: renvoie le type de l'objet
			TypeObjet* GetTypeObjet() const;
		
		private:
			/// Type de l'objet
			TypeObjet* mTypeObjet;
	};
}

#endif
