/**
* \file projet.hpp
* \brief Fichier de definition
* \author Yoha
* \version alpha-0.0.07
* \date Aot 2009
* 
* Ce fichier s'occupe d'assurer la definition de variables mathematiques ou globales
*
*/

#ifndef PROJET_HPP
#define PROJET_HPP

/// Mode dynamique
#define SFML_DYNAMIC

// variables mathematiques
/// Quart de PI
#define QPI 0.78539816
/// Moitiee de PI
#define DPI 1.57079632
/// Double de PI
#define PI2 6.28318530
/// Valeur de PI
#define  PI 3.14159265

// variables globales du systeme de jeu
/// Inverse des chances de presense d'une resource
#define CHANCES_RESSOURCE 50

// adresses des repertoires
/// repertoire des images
#define R_IMAGES "./Donnees/Images/"
/// repertoire des images des structures des batiments
#define R_IMAGES_BATIMENTS_STRUCTURES "./Donnees/Images/Batiments/Structures/"
/// repertoire des mages des boutons des batiments
#define R_IMAGES_BATIMENTS_BOUTONS "./Donnees/Images/Batiments/Boutons/"
/// repertoire des images des objets
#define R_IMAGES_OBJETS "./Donnees/Images/Objets/"
/// repertoire des images des ressources
#define R_IMAGES_RESSOURCES "./Donnees/Images/Ressources/"
/// repertoire des musiques
#define R_MUSIQUES "./Donnees/Musiques/"
/// repertoire des fichiers de configuration
#define R_CONFIG "./Donnees/Config/"

#endif
