/**
* \file race.hpp
* \brief Race
* \author Yoha
* \version alpha-0.0.07
* \date Juin 2009
*
* Definition de la classe des races
*
*/

#ifndef RACE_HPP
#define RACE_HPP

#include <string>

namespace GS
{
	class Race
	{
		public:
			/// \brief Constructeur
			Race();
			/// \brief Destructeur
			~Race();
			
			/// \brief Definit la description de la rce
			/// \param description Description a charger
			void SetDescription(const std::string description);
			/// \brief Definit la denomination pour un individu male
			/// \param denomination Denomination a charger
			void SetDenominationSingulierMasculin(const std::string denomination);
			/// \brief Definit la denomination pour un individu femmelle
			/// \param denomination Denomination a charger
			void SetDenominationSingulierFeminin(const std::string denomination);
			/// \brief Definit la denomination pour des individus males
			/// \param denomination Denomination a charger
			void SetDenominationPlurielMasculin(const std::string denomination);
			/// \brief Definit la denomination pour des individus femelles
			/// \param denomination Denomination a charger
			void SetDenominationPlurielFeminin(const std::string denomination);
		
		private:
			unsigned int mId;
			std::string mDescription;
			std::string mDenominationSingulierMasculin;
			std::string DenominationSingulierFeminin;
			std::string DenominationPlurielMasculin;
			std::string DenominationPlurielFeminin;
	};
}

#endif
