#ifndef STATUT_CPP
#define STATUT_CPP

#include "statut.hpp"

#include "data.hpp"

namespace GS
{
	Statut::Statut()
	{
		mNom = "Statut";
		mValeurDefaut = 0;
		mValeur = 0;
		
		mImageContourValeur = new sf::Image(1, 1, sf::Color(127, 127, 0, 255));
		mSpriteContourValeur = new sf::Sprite(*mImageContourValeur);
		mSpriteContourValeur->Resize(Prgm::BarresChargement::Largeur + 2 * Prgm::BarresChargement::EpaisseurContours, Prgm::BarresChargement::Hauteur + 2 * Prgm::BarresChargement::EpaisseurContours);
		
		mImageFondValeur = new sf::Image(1, 1, sf::Color(0, 0, 0, 255));
		mSpriteFondValeur = new sf::Sprite(*mImageFondValeur);
		mSpriteFondValeur->Resize(Prgm::BarresChargement::Largeur, Prgm::BarresChargement::Hauteur);
		
		mImageValeur = new sf::Image(1, 1, sf::Color(255, 255, 255, 255));
		mSpriteValeur = new sf::Sprite(*mImageValeur);
		
		mTexte = new sf::String(mNom);
		mTexte->SetColor(sf::Color(0, 0, 0, 255));
		mTexte->SetSize(Prgm::BarresChargement::TailleTexte);
	}
	
	Statut::~Statut()
	{
		delete mImageContourValeur;
		delete mSpriteContourValeur;
		
		delete mImageFondValeur;
		delete mSpriteFondValeur;
		
		delete mImageValeur;
		delete mSpriteValeur;
		
		delete mTexte;
	}
	
	void
	Statut::Dessine(sf::RenderTarget* const App) const
	{
		App->Draw(*mSpriteContourValeur);
		App->Draw(*mSpriteFondValeur);
		App->Draw(*mSpriteValeur);
		App->Draw(*mTexte);
	}
	
	void
	Statut::SetNom(const std::string nom)
	{
		mNom = nom;
		mTexte->SetText(mNom);
	}
	
	void
	Statut::SetValeurDefaut(const double valeur)
	{
		mValeurDefaut = valeur;
	}
	
	void
	Statut::SetValeur(const double valeur)
	{
		mValeur = valeur;
		mSpriteValeur->Resize(Prgm::BarresChargement::Largeur * mValeur / 20, Prgm::BarresChargement::Hauteur);
	}
	
	void
	Statut::SetPosition(const double x, const double y)
	{
		mSpriteContourValeur->SetPosition(x, y);
		mSpriteFondValeur->SetPosition(x + Prgm::BarresChargement::EpaisseurContours, y + Prgm::BarresChargement::EpaisseurContours);
		mSpriteValeur->SetPosition(x + Prgm::BarresChargement::EpaisseurContours, y + Prgm::BarresChargement::EpaisseurContours);
		mTexte->SetPosition(x + Prgm::BarresChargement::EpaisseurContours + Prgm::BarresChargement::Largeur / 2 - mTexte->GetRect().GetWidth() / 2, y + Prgm::BarresChargement::EpaisseurContours);
	}
	
	std::string
	Statut::GetNom() const
	{
		return mNom;
	}
	
	double
	Statut::GetValeurDefaut() const
	{
		return mValeurDefaut;
	}
}

#endif
