#ifndef TEXTE_CPP
#define TEXTE_CPP

#include "texte.hpp"

#include "fonctions.hpp"
#include "data.hpp"

Texte::Texte(bool fond)
{
	if (fond && Prgm::Textes::Fond)
		mFond = new sf::Sprite(*Prgm::Textes::Fond);
	else
		mFond = NULL;
	
	mTexte = new sf::String("");
	mTexte->SetColor(sf::Color(0, 0, 0, 255));
	mTexte->SetSize(15);
}

Texte::~Texte()
{
	delete mFond;
	delete mTexte;
}

void
Texte::Dessine(sf::RenderTarget* const App) const
{
	if ((std::string)(mTexte->GetText()) != "")
	{
		if (mFond)
			App->Draw(*mFond);
		
		App->Draw(*mTexte);
	}
}

void
Texte::SetPosition(const double x, const double y)
{
	if (mFond)
		mFond->SetPosition(x, y + mTexte->GetSize() / 5);
	mTexte->SetPosition(x, y);
}

void
Texte::SetText(const std::string texte)
{
	unsigned int i = 0;
	unsigned int debutLigne = 0;
	unsigned int longueur = texte.size();
	double longueurMax = 0;
	while (i < longueur)
	{
		if (texte.substr(i, 1) == "\n")
		{
			mTexte->SetText(texte.substr(debutLigne, i - debutLigne));
			if (mTexte->GetRect().GetWidth() > longueurMax)
				longueurMax = mTexte->GetRect().GetWidth();
			debutLigne = i;
		}
		i++;
	}
	mTexte->SetText(texte.substr(debutLigne, longueur - debutLigne));
	if (mTexte->GetRect().GetWidth() > longueurMax)
		longueurMax = mTexte->GetRect().GetWidth();
	
	mTexte->SetText(texte);
	if (mFond)
		mFond->Resize(longueurMax, mTexte->GetRect().GetHeight());
}

sf::FloatRect
Texte::GetRect() const
{
	return mTexte->GetRect();
}

#endif
