/**
* \file texte.hpp
* \brief Texte
* \author Yoha
* \version alpha-0.0.07
* \date Aot 2009
*
* Definition des textes
*
*/

#ifndef TEXTE_HPP
#define TEXTE_HPP

/// Mode dynamique
#define SFML_DYNAMIC

#include <iostream>
#include <SFML/Graphics.hpp>

/// Afficheur de texte sur la fenetre
class Texte
{
	public:
		/// \brief Constructeur
		/// \param fond Afficher un fond (true), par dfaut, ou non (false)
		Texte(bool fond = true);
		/// \brief Destructeur
		~Texte();
		
		/// \brief Methode de dessin du texte
		/// \param App Pointeur sur la fenetre de rendu
		void Dessine(sf::RenderTarget* const App) const;
		
		/// \brief Accesseur: definit la position du texte
		/// \param x Abscisse du texte
		/// \param y Ordonnee du texte
		void SetPosition(const double x, const double y);
		/// \brief Acesseur: definit le texte affiche
		/// \param texte Nouveau texte
		void SetText(const std::string texte);
		
		///  \brief Retourne les dimensions du texte
		sf::FloatRect GetRect() const;
		
	private:
		/// Sprite de fond
		sf::Sprite* mFond;
		/// Afficheur du texte
		sf::String* mTexte;
};

#endif
