#ifndef TYPETERRAIN_CPP
#define TYPETERRAIN_CPP

#include "typeterrain.hpp"

#include "fonctions.hpp"

namespace GS
{
	TypeTerrain::TypeTerrain()
	{
		mProbabilite = 0;
		mFacteurVitesse = 0;
		mConstructible = false;
		mPorteRessources = false;
		mSpriteTeste = false;
		mSprite = NULL;
	}
	
	TypeTerrain::~TypeTerrain()
	{
		delete mSprite;
	}
	
	bool
	TypeTerrain::TestSprite() // verifie l'existence d'un sprite
	{
		if (mSprite)
			return true;
		else
		{
			if (!mSpriteTeste)
			{
				CastErreur("Erreur de chargement d'un sprite de terrain", true);
				mSpriteTeste = true;
			}
			
			return false;
		}
	}
	
	void
	TypeTerrain::SetSprite(const sf::Sprite* const sp)
	{
		delete mSprite;
		mSprite = new sf::Sprite(*sp);
	}
	
	void
	TypeTerrain::SetPorteRessources(const bool porte)
	{
		mPorteRessources = porte;
	}
	
	void
	TypeTerrain::SetFacteurVitesse(const double vitesse)
	{
		mFacteurVitesse = vitesse;
	}
	
	void
	TypeTerrain::SetConstructible(const bool constructible)
	{
		mConstructible = constructible;
	}
	
	void
	TypeTerrain::SetProbabilite(const double probabilite)
	{
		mProbabilite = probabilite;
	}
	
	sf::Sprite*
	TypeTerrain::GetSprite() const
	{
		return mSprite;
	}
	
	bool
	TypeTerrain::GetPorteRessources() const
	{
		return mPorteRessources;
	}
	
	double
	TypeTerrain::GetFacteurVitesse() const
	{
		return mFacteurVitesse;
	}
	
	bool
	TypeTerrain::GetConstructible() const
	{
		return mConstructible;
	}
	
	double
	TypeTerrain::GetProbabilite() const
	{
		return mProbabilite;
	}
}

#endif
