#ifndef TYPETERRESSOURCE_CPP
#define TYPETERRESSOURCE_CPP

#include "typeterressource.hpp"

#include "fonctions.hpp"
#include "data.hpp"

namespace GS
{
	TypeTerRessource::TypeTerRessource()
	{
		mId = 0;
		mSpriteTeste = false;
		mRessourceParSeconde = 0;
		mNom = "";
		mAction = "";
		mSprite = NULL;
		mTypeRessource = NULL;
	}
	
	TypeTerRessource::~TypeTerRessource()
	{
		delete mSprite;
	}
	
	void
	TypeTerRessource::Dessine(sf::RenderTarget* const App, const double x, const double y)
	{
		if (mSprite)
		{
			mSprite->SetPosition(x, y);
			App->Draw(*mSprite);
		}
	}
	
	bool
	TypeTerRessource::TestSprite()
	{
		if (mSprite)
			return true;
		else
		{
			if (!mSpriteTeste)
			{
				CastErreur("Erreur lors du chargement du sprite de la ressource de terrain \"" + mNom + "\"", false);
				mSpriteTeste = true;
			}
			
			return false;
		}
	}
	
	void
	TypeTerRessource::SetId(const int num)
	{
		mId = num;
	}
	
	void
	TypeTerRessource::SetSprite(const sf::Sprite* const sprite)
	{
		delete mSprite;
		mSprite = new sf::Sprite(*sprite);
		mSprite->Resize(Prgm::TerRessources::Largeur, Prgm::TerRessources::Hauteur);
	}
	
	void
	TypeTerRessource::SetNom(const std::string nom)
	{
		mNom = nom;
	}
	
	void
	TypeTerRessource::SetAction(const std::string action)
	{
		mAction = action;
	}
	
	void
	TypeTerRessource::SetTypeRessource(TypeRessource* tr)
	{
		mTypeRessource = tr;
	}
	
	void
	TypeTerRessource::SetRessourceParSeconde(const double quantite)
	{
		mRessourceParSeconde = quantite;
	}
	
	int
	TypeTerRessource::GetId() const
	{
		return mId;
	}
	
	int
	TypeTerRessource::GetResId() const
	{
		if (mTypeRessource)
			return mTypeRessource->GetId();
		else
			return 0;
	}
	
	TypeRessource*
	TypeTerRessource::GetTypeRessource() const
	{
		return mTypeRessource;
	}
	
	std::string
	TypeTerRessource::GetAction() const
	{
		return mAction;
	}
	
	double
	TypeTerRessource::GetRessourceParSeconde() const
	{
		return mRessourceParSeconde;
	}
}

#endif
